//
//  BMCollection.m
//  YKBookmarks
//
//  Created by KOYAMA Yoshiaki on Thu Feb 10 2005.
//  Copyright (c) 2005 KOYAMA Yoshiaki. All rights reserved.
//

#import "BMCollection.h"


@implementation BMCollection

- (id) init {
    if (self = [super init])
    {
        NSArray * keys      = [NSArray arrayWithObjects: @"title", nil];
        NSArray * values    = [NSArray arrayWithObjects: @"New Collection", nil];
        properties = [[NSMutableDictionary alloc] initWithObjects: values forKeys: keys];
        
        bookmarks = [[NSMutableArray alloc] init];
    }
    return self;
}

- (void) dealloc {
    [properties release];
    [bookmarks release];
    
    [super dealloc];
}



- (NSMutableDictionary *) properties {
    return properties;
}

- (void) setProperties: (NSDictionary *)newProperties {
    if (properties != newProperties)
    {
        [properties autorelease];
        properties = [[NSMutableDictionary alloc] initWithDictionary: newProperties];
    }
}


- (NSMutableArray *) bookmarks {
    return bookmarks;
}

- (void) setBookmarks: (NSArray *)newBookmarks {
    if (bookmarks != newBookmarks)
    {
        [bookmarks autorelease];
        bookmarks = [[NSMutableArray alloc] initWithArray: newBookmarks];
    }
}

- (void)encodeWithCoder:(NSCoder *)encoder {

	[encoder encodeObject:properties forKey:@"properties"];
	[encoder encodeObject:bookmarks forKey:@"bookmarks"];

}

- (id)initWithCoder:(NSCoder *)decoder {

	properties = [[decoder decodeObjectForKey:@"properties"] retain];
	bookmarks = [[decoder decodeObjectForKey:@"bookmarks"] retain];

	return self;
}

@end
