#import "BookmarkArrayController.h"
#import "Bookmark.h"

NSString *BookmarkMovedRowsType = @"BOOKMARK_MOVED_ROWS_TYPE";

@implementation BookmarkArrayController

- (void)awakeFromNib {
    NSFont *aFont;
    NSTableColumn *column;
	NSCell *cell;

	aFont = [NSFont fontWithName:@"HiraKakuPro-W3" size:10];

	column = [_bookmarkTableView tableColumnWithIdentifier:@"title"];
//	[column setEditable:NO];
    cell = [column dataCell];
//	[cell setFont:aFont];

	//hbOEhbv̐ݒ
    [_bookmarkTableView registerForDraggedTypes:
	[NSArray arrayWithObjects:BookmarkMovedRowsType, nil]];

	//_uNbN̐ݒ
	[_bookmarkTableView setTarget:self];
	[_bookmarkTableView setDoubleAction:@selector(openDoubleFile:)];
}


- (BOOL)tableView:(NSTableView *)tableView writeRows:(NSArray *)rows
	toPasteboard:(NSPasteboard *)pboard {
    NSArray *typesArray = [NSArray arrayWithObjects:BookmarkMovedRowsType, nil];

	[pboard declareTypes:typesArray owner:self];
    [pboard setPropertyList:rows forType:BookmarkMovedRowsType];
}

- (NSDragOperation)tableView:(NSTableView *)tableView validateDrop:(id <NSDraggingInfo>)info 
	proposedRow:(int)row proposedDropOperation:(NSTableViewDropOperation)operation {
    
    NSDragOperation dragOperation = NSDragOperationCopy;
  
    if ([info draggingSource] == _bookmarkTableView) {
		dragOperation =  NSDragOperationMove;
    }

    [tableView setDropRow:row dropOperation:NSTableViewDropAbove];
	
    return dragOperation;
}

- (BOOL)tableView:(NSTableView *)tableView acceptDrop:(id <NSDraggingInfo>)info 
	row:(int)row dropOperation:(NSTableViewDropOperation)operation {
	NSArray *rows;
	int originRow;
	id object;
    NSArray *objects;

	objects = [self arrangedObjects];

	rows = [[info draggingPasteboard] propertyListForType:BookmarkMovedRowsType];

	// ̍s
	originRow = [[rows objectAtIndex:0] intValue];	

	// e[u̍s̓ւ
    if ([info draggingSource] == _bookmarkTableView) {
		object = [objects objectAtIndex:originRow];
		if (originRow > row) {
			[self removeObjectAtArrangedObjectIndex:originRow];
			[self insertObject:object atArrangedObjectIndex:row];
		} else {
			[self removeObjectAtArrangedObjectIndex:originRow];
			[self insertObject:object atArrangedObjectIndex:row-1];
		}

	}	
	return YES;
}

// _uNbN̏
- (void)openDoubleFile:(id)sender {
	NSWorkspace *wspace = [NSWorkspace sharedWorkspace];
    NSMutableDictionary *properties;
	NSURL *url;
	NSString *urlString;
	Bookmark *bookmark;
	NSArray *array;

	array = [self selectedObjects];
	bookmark = [array objectAtIndex:0];
	properties = [bookmark properties];

	urlString = [properties objectForKey:@"url"];

	if (urlString != nil) {
		url = [NSURL URLWithString:urlString];
		[wspace openURL:url];
	}
}

#pragma mark -
#pragma mark === delegate ====

- (BOOL)tableView:(NSTableView *)aTableView shouldSelectTableColumn:(NSTableColumn *)aTableColumn {
	return NO;
}

@end
