#import "CollectionArrayController.h"

NSString *CollectionMovedRowsType = @"COLLECTION_MOVED_ROWS_TYPE";

@implementation CollectionArrayController

- (void)awakeFromNib
{
	//hbOEhbv̐ݒ
    [_collectionTableView registerForDraggedTypes:
	[NSArray arrayWithObjects:CollectionMovedRowsType, nil]];
}

- (BOOL)tableView:(NSTableView *)tableView writeRows:(NSArray *)rows
	toPasteboard:(NSPasteboard *)pboard {
    NSArray *typesArray = [NSArray arrayWithObjects:CollectionMovedRowsType, nil];

	[pboard declareTypes:typesArray owner:self];
    [pboard setPropertyList:rows forType:CollectionMovedRowsType];
}

- (NSDragOperation)tableView:(NSTableView *)tableView validateDrop:(id <NSDraggingInfo>)info 
	proposedRow:(int)row proposedDropOperation:(NSTableViewDropOperation)operation {
    
    NSDragOperation dragOperation = NSDragOperationCopy;
  
    if ([info draggingSource] == _collectionTableView) {
		dragOperation =  NSDragOperationMove;
    }
    [tableView setDropRow:row dropOperation:NSTableViewDropAbove];
	
    return dragOperation;
}

- (BOOL)tableView:(NSTableView *)tableView acceptDrop:(id <NSDraggingInfo>)info 
	row:(int)row dropOperation:(NSTableViewDropOperation)operation {
	NSArray *rows;
	int originRow;
	id object;
    NSArray *objects;

	objects = [self arrangedObjects];

	rows = [[info draggingPasteboard] propertyListForType:CollectionMovedRowsType];
	// ̍s
	originRow = [[rows objectAtIndex:0] intValue];	

	// e[u̍s̓ւ
    if ([info draggingSource] == _collectionTableView) {
		object = [objects objectAtIndex:originRow];
		if (originRow > row) {
			[self removeObjectAtArrangedObjectIndex:originRow];
			[self insertObject:object atArrangedObjectIndex:row];
//			[self setSelectionIndex:row];
		} else {
			[self removeObjectAtArrangedObjectIndex:originRow];
			[self insertObject:object atArrangedObjectIndex:row-1];
//			[self setSelectionIndex:row-1];
		}

	}
	


	return YES;
}

#pragma mark -
#pragma mark === delegate ====

- (BOOL)tableView:(NSTableView *)aTableView shouldSelectTableColumn:(NSTableColumn *)aTableColumn {
	return NO;
}


@end
